"""Subclass of SettingsFrame, which is generated by wxFormBuilder."""

import wx
from os import X_OK
import shutil
import simple_ssh.gui as gui
from simple_ssh.SimpleSSHNewConnection import SimpleSSHNewConnection

# Implementing SettingsFrame
class SimpleSSHSettingsFrame( gui.SettingsFrame ):
    def __init__( self, parent, main ):
        gui.SettingsFrame.__init__( self, parent )
        self.main = main
        self.consoles = self.m_console.Items
        self.m_console.SetItems(list(filter(lambda cmd: shutil.which(cmd, mode=X_OK), self.consoles)))

    # Handlers for SettingsFrame events.
    def add_config( self, event ):
        SimpleSSHNewConnection(None, self.main).Show()

    def remove_config( self, event ):
        selected = self.m_notebook.GetSelection()
        server = self.m_notebook.GetPageText(selected)
        self.main.servers_to_remove.append(server)
        self.m_notebook.DeletePage(selected)

    def save_settings( self, event ):
        self.main.save_config()

    def close_settings( self, event ):
        self.Close()

    def tab_changed( self, event ):
        selected = self.m_notebook.GetSelection()
        tab = self.m_notebook.GetPageText(selected)
        if tab == "General":
            self.btn_remove.Disable()
        else:
            self.btn_remove.Enable()